#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "font.h"
int fontW, fontH, fontA;

static void init_font(char *fn,int size,int hadd)
{
  font_init(96);
  font_load_file(0, fn, size);

  int fw1, fh1, fa1;
  font_dimensions(0, &fw1,&fh1,&fa1);

  fh1+= hadd; fa1+= hadd;

  font_set_cell(0,fw1,fh1,fa1);

  fontW= fw1; fontH= fh1; fontA= fa1;
}                                    

void print_row(int r)
{
  int i;
  glyph_t *G;
  G= font_render(0, r);
  printf("/* %c */ { ", r);
  for(i=0;i<fontW*fontH;i++)
  {
    printf("%d,",G->data[i]);
    if ((i-1)%20==0) printf("\n");
  }
  printf("},\n");
}

void print_table()
{
  int i;
  printf("static const unsigned char font[127-32][fontW*fontH]= {\n");
  for(i=32;i<127;i++)
    print_row(i);
  printf("};\n");
}

int main(int argc,char **argv)
{
  init_font(argv[1],atoi(argv[2]),atoi(argv[3]));
  printf("#define fontW %d\n",fontW);
  printf("#define fontH %d\n",fontH);
  print_table();
}
