
void editor_init(int nrows,int ncols);
int editor_save(char *fn);
int editor_load(char *fn);
void editor_clear();

/***********************************************************************
  The following functions are defined by the environment. The first one
  prints a string at the given row,col position. inv is nonzero if the
  string is to be in reverse video, eg. for the cursor etc.
 ***********************************************************************/
void editor_print(int r,int c,int inv,char *str,int len);

/***********************************************************************
  Key specification is as follows:
   cls= 'A'    arrows
     val= 'U'    up
          'D'    down
          'L'    left
          'R'    right
          'H'    home
          'E'    end
   cls= 'P'    page movement
     val= 'U'    page up
     val= 'D'    page down
   cls= 0
     val=X       ASCII char x
   cls= 'C'    control character
     val= 'N'    newline
          'B'    backspace
 ***********************************************************************/
void editor_key(int cls, int val);
