
int orun(char *fn, unsigned char *p, unsigned char *e);
int orun_file(char *fn);
extern void (*oerr)(char *fn, int line);
extern void (*oprint)(const char *data, int size);



/***********************************************************************
 *                                                                     *
 *                              BUILTINS                               *
 *                                                                     *
 ***********************************************************************
  In order to integrate the engine with your program, you need to define
  your builtin functions so that user programs may invoke them. A builtin
  function can take up to 10 arguments. It can return a value, or it may
  not. There are two types of values: integers and strings.

       Type         C Type      Representation
      Integer        int            i
      String        char*           s
       none          void           v

  You declare a list of builtin functions using the BUILTINS macro.
  It consists of builtin function declarations, using the BF macro.
  For example:
  #define BUILTINS \
     BF(echo,v,s) \
     BF(mul,i,i,i)
  will define two functions: echo and mul. The return type for the first
  function is void (the second parameter to BF=v). The second one takes
  two integers and returns another integer. 

  Such declarations must appear here in order for the engine to find them.
 ***********************************************************************/

#define BUILTINS \
  BF(red,v,i) \
  BF(green,v,i) \
  BF(blue,v,i) \
  BF(width,v,i) \
  BF(line,v,i) \
  BF(right,v,i) \
  BF(left,v,i) \
  BF(move,v,i) \
  BF(clear,v) \
  BF(tick,v,i)  \
  BF(circle,v,i)  \
  BF(save,v) \
  BF(restore,v) 
