

void read_filep_real(FILE *f,char**buf, size_t *len) {
    char *xb;
    static const int rsize=2000;
    int r;
   int eno;
    int pos= *len;

    xb= malloc(rsize);
    r= fread(xb, 1, rsize, f);
    if (r<0) goto read_error;
    *len+= r;
    if (r==rsize) {
        read_filep_real(f, buf,len);
    } else {
       if (ferror(f)) goto read_error;
       *buf= malloc(*len+1);
    }
        
    memcpy(*buf + pos, xb, r);
    free(xb);

    return ;

read_error:
    eno= errno;
    free(xb);
    errno= eno;
    *buf= 0;
}

void read_filep(FILE *f,char**buf, size_t *len) {
    *len= 0;
    read_filep_real(f,buf,len);
    if (*buf)
       (*buf)[*len]= 0;
}

char* file_read_all(char *name, int *len)
{
   FILE *f;
   char *buf;
   f= fopen(name,"r");
   if (!f)
      exit(fprintf(stderr,"can't open file %s:%s\n", name, strerror(errno)));
   read_filep(f, &buf, (size_t*) len);
   if (!buf)
      exit(fprintf(stderr,"can't read file %s:%s\n", name, strerror(errno)));
   fclose(f);
   return buf;
}
