
static int icls[256];

static void clsrange(int s,int e, int c)
{
  while(s<=e) icls[ s++ ]= c;
}

static void clsstr(char *s, int c)
{
  while(*s) icls[ *(s++) ]= c;
}

static void clsself(char *s)
{
  while(*s) { icls[ *s ]= *s; s++; }
}

static void init_cls()
{
  int i;
  if (icls[' ']) return ;
  icls[0]= 'E';
  clsrange(1, ' ', ' ');      icls['\n']= 'l';
  clsstr("+-*/%[](,);{}=", 's');
  clsrange('a','z', 'a'); clsrange('A','Z', 'a'); icls['_']= 'a';
  clsrange('0','9', '0');
  icls['\'']= 'q';
  clsself(":<>!#");
}

void token(unsigned char *tk, int len, unsigned int type)
{
  printf("[%3d]: <", type);
  fwrite(tk,1,len, stdout);
  printf(">\n");
}

void parse_string(unsigned char *str)
{
  unsigned int c;
  unsigned char *e;
  init_cls();

again:
  c= *str;
  switch(icls[c])
  {
  case 'E': return ;
  case 'a': 
     for(e=str;icls[*e]=='0' || icls[*e]=='a';e++) ;
     token(str, e-str, 'a'); str= e; goto again;
  case '0': 
     for(e=str;icls[*e]=='0';e++) ;
     token(str, e-str, '0'); str= e; goto again;
  case 'q': 
     for(e=str+1;icls[*e]!='q' && icls[*e]!='E' && icls[*e]!='l';e++) ;
     if (icls[*e]=='q') 
     {
        token(str+1, e-str-1, 'q'); 
        str= e+1;
        goto again;
     }
     printf("error in quotes\n");
     return ;
  case 's': goto single; 

  case ' ': 
  case   0:
  case 'l': goto next;

  case '<': if (str[1]=='=') { token(str, 2, 'L'); str+=2; goto again; }
            else goto single;
  case '>': if (str[1]=='=') { token(str, 2, 'G'); str+=2; goto again; }
            else goto single;
  case '!': if (str[1]=='=') { token(str, 2, 'N'); str+=2; goto again; }
            else goto single;
  case ':': if (str[1]=='=') { token(str, 2, 'A'); str+= 2; goto again; }
            else goto single;
  case '#': for(e=str;icls[*e]!='E' && icls[*e]!='l';e++) ;
            str= e; goto again;
  }

single:
  token(str, 1, str[0]); 
next:
  str++;
  goto again;
}


